#include "stdafx.h"
#include "iconv.h"
#include "iconv_impl.h"

/************************************************************************/
/*  [1/22/2018 Home];
/*  ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
std::string convert2(const char *from, const char* to, const char* inbuf, const size_t &inbufsize)
{
	int iconv_ret = 0;
	// ַת;
	iconv_t hIconv = iconv_open(to, from);
	if (-1 == (int)hIconv)
		return "";//ʧܣֵַ֧ܲ

	size_t insize = inbufsize;
	std::string strout;
	// ѭ;
	size_t outsize = 512;
	// 513һλַ;
	char out[513] = { 0 };

	while (insize > 0)
	{
		outsize = 512;
		memset(out, 0, outsize);
		// outַ治,Աظʹ;
		char *p = out;

		// ʼת;
		iconv_ret = iconv(hIconv, (const char**)(&inbuf), &insize, &p, &outsize);
		if (((iconv_ret == (size_t)-1) && (E2BIG == errno)) || (iconv_ret != (size_t)-1))
		{
			// outpַͬ, p-outָõ;
			//strout.append(out, p - out);
			strout.insert(strout.size(), out, p - out);
		}
	}

	//رַת
	iconv_close(hIconv);

	return strout;
}

std::string convert(const char *from, const char* to, const char* inbuf, const size_t &inbufsize)
{
	int iconv_ret = 0;
	// ַת;
	iconv_t hIconv = iconv_open(to, from);
	if (-1 == (int)hIconv)
		return "";//ʧܣֵַ֧ܲ

	int status = 0;
	int times = (inbufsize / 512) + 1;	// ԤƿתĴ;
	iconv(hIconv, NULL, NULL, NULL, NULL);
	size_t insize = inbufsize;
	std::string strout;
	// ѭ;
	size_t outsize = 512;
	// 513һλַ;
	char out[513] = { 0 };

	while (insize > 0)
	{
		outsize = 512;
		memset(out, 0, outsize);
		// outַ治,Աظʹ;
		char *p = out;

		// ʼת;
		//times--;
		iconv_ret = iconv(hIconv, (const char**)(&inbuf), &insize, &p, &outsize);
		if (out != p)
		{
			int saved_errno = errno;
			strout.insert(strout.size(), out, p - out);
			errno = saved_errno;
		}

		if (iconv_ret == (size_t)(-1))
		{
			if (errno == EILSEQ)
			{//	ЧĶֽ;
				int one = 1;
				// Ƿж;
				iconvctl(hIconv, ICONV_SET_DISCARD_ILSEQ, &one);
				status = -3;
			}
			else if (errno == EINVAL)
			{// һĶֽ;
				if (inbufsize == 0)
				{
					status = -4;
					goto done;
				}
				else
				{
					break;
				}
			}
			else if (errno == E2BIG)
			{// *outbufû㹻Ŀռ;
				status = -5;
				//goto done;
			}
			else {
				status = -6;
				goto done;
			}
		}
		/*if (((iconv_ret == (size_t)-1) && (E2BIG == errno)) || (iconv_ret != (size_t)-1))
		{
		// outpַͬ, p-outָõ;
		//strout.append(out, p - out);
		strout.insert(strout.size(), out, p - out);
		}*/
	}

done:
	//رַת
	iconv_close(hIconv);

	return strout;
}

/************************************************************************/
/*  [7/26/2016 IT];
/*  ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
TString EnCode_UTF8URL(const TCHAR* pText)
{
	if (pText == NULL || pText[0] == '\0')
		return _T("");

	std::string tt = "";
	std::string dd = "";
	//ASCII2UTF8(pText, tt);
#ifdef UNICODE 
	tt = convert("UCS-2LE", "UTF-8", (char*)pText, _tcslen(pText) * sizeof(TCHAR));
#else
	tt = convert("ASCII", "UTF-8", pText, strlen(pText));
#endif

	size_t len = tt.length();
	for (size_t i = 0; i < len; i++)
	{
		if (isalnum((BYTE)tt.at(i)))
		{
			char tempbuff[2] = { 0 };
			sprintf_s(tempbuff, "%c", (BYTE)tt.at(i));
			dd.append(tempbuff);
		}
		else if (isspace((BYTE)tt.at(i)))
		{
			dd.append("+");
		}
		else
		{
			char tempbuff[4];
			sprintf_s(tempbuff, "%%%X%X", ((BYTE)tt.at(i)) >> 4, ((BYTE)tt.at(i)) % 16);
			dd.append(tempbuff);
		}
	}

#ifdef UNICODE 
	//tt = convert("ASCII", "UCS-2LE", dd.c_str(), dd.size());
	//TString result;
	//result.append((TCHAR*)tt.c_str(), dd.size());
	//return result;
	// 4д,򻯳һ;
	return TString().append((TCHAR*)convert("ASCII", "UCS-2LE", dd.c_str(), dd.size()).c_str(), dd.size());
#else
	return dd;
#endif

}

void EnCode_UTF8URL(const TCHAR* pText, TString& strResult)
{
	std::string tt = "";

	//ASCII2UTF8(pText, tt);
#ifdef UNICODE 
	std::string result = "";
	tt = convert("UCS-2LE", "UTF-8", (char*)pText, _tcslen(pText) * sizeof(TCHAR));
#else
	tt = convert("ASCII", "UTF-8", pText, strlen(pText));
#endif

	size_t len = tt.length();
	for (size_t i = 0; i < len; i++)
	{
		if (isalnum((BYTE)tt.at(i)))
		{
			char tempbuff[2] = { 0 };
			sprintf_s(tempbuff, "%c", (BYTE)tt.at(i));
#ifdef UNICODE
			result.append(tempbuff);
#else
			strResult.append(tempbuff);
#endif
		}
		else if (isspace((BYTE)tt.at(i)))
		{
#ifdef UNICODE
			result.append("+");
#else
			strResult.append("+");
#endif
		}
		else
		{
			char tempbuff[4];
			sprintf_s(tempbuff, "%%%X%X", ((BYTE)tt.at(i)) >> 4, ((BYTE)tt.at(i)) % 16);
#ifdef UNICODE
			result.append(tempbuff);
#else
			strResult.append(tempbuff);
#endif
		}
	}

#ifdef UNICODE 
	//tt = convert("ASCII", "UCS-2LE", dd.c_str(), dd.size());
	//TString result;
	//result.append((TCHAR*)tt.c_str(), dd.size());
	// ϴ,򻯳һ;
	strResult.append((TCHAR*)convert("ASCII", "UCS-2LE", result.c_str(), result.size()).c_str(), result.size());
#endif
}

//ΪUrlʹ
char CharToInt(char ch)
{
	if (ch >= '0' && ch <= '9')return (char)(ch - '0');
	if (ch >= 'a' && ch <= 'f')return (char)(ch - 'a' + 10);
	if (ch >= 'A' && ch <= 'F')return (char)(ch - 'A' + 10);
	return -1;
}

char StrToBin(IN char(&str)[2])
{
	char tempWord[2];
	char chn;

	tempWord[0] = CharToInt(str[0]);                         //make the B to 11 -- 00001011
	tempWord[1] = CharToInt(str[1]);                         //make the 0 to 0  -- 00000000

	chn = (tempWord[0] << 4) | tempWord[1];                //to change the BO to 10110000

	return chn;
}


/************************************************************************/
	/*  [7/26/2016 IT];
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	string DeCode_URLGB2312(IN const CHAR* pURLText)
	{
		string output = "";
		char tmp[2];
		int i = 0, idx = 0, ndx, len = strlen(pURLText);

		while (i < len) {
			if (pURLText[i] == '%')
			{
				tmp[0] = pURLText[i + 1];
				tmp[1] = pURLText[i + 2];
				output += StrToBin(tmp);
				i = i + 3;
			}
			else if (pURLText[i] == '+')
			{
				output += ' ';
				i++;
			}
			else {
				output += pURLText[i];
				i++;
			}
		}

		return output;
	}

	void DeCode_URLGB2312(IN const CHAR* pURLText, OUT string& strResult)
	{
		char tmp[2];
		int i = 0, idx = 0, ndx, len = strlen(pURLText);

		while (i < len) {
			if (pURLText[i] == '%')
			{
				tmp[0] = pURLText[i + 1];
				tmp[1] = pURLText[i + 2];
				strResult += StrToBin(tmp);
				i = i + 3;
			}
			else if (pURLText[i] == '+')
			{
				strResult += ' ';
				i++;
			}
			else {
				strResult += pURLText[i];
				i++;
			}
		}
	}
