-- ----------------------------
-- Table structure for supplier
-- Ӧ̱;
-- ----------------------------
CREATE TABLE "supplier" (
"supplier_id"  INTEGER NOT NULL,		                        -- Ӧid; 
"supplier_company_type" TEXT,                                   -- Ӧҵ:,,,˽Ӫ,...
"supplier_business_type" TEXT,                                  -- Ӧ(Ҫ)ҵ,ʵҵ;
"supplier_name"  TEXT,					                        -- Ӧ;
"supplier_address"  TEXT,				                        -- Ӧ̵ַ;
"supplier_remarks"  TEXT,				                        -- Ӧ̱ע;
"supplier_fax"  TEXT,					                        -- Ӧ̴;
"supplier_web_site"  TEXT,				                        -- Ӧվ;
"supplier_postcode"  TEXT,				                        -- Ӧ;
"supplier_established_date"  TEXT,		                        -- Ӧ̳(ʹUTCʱ);
"supplier_credit_standing"  TEXT,		                        -- Ӧ״;
PRIMARY KEY ("supplier_id" ASC)
);

-- ----------------------------
-- Table structure for supplier_contacts
-- Ӧϵ˱;
-- ----------------------------
DROP TABLE IF EXISTS "main"."supplier_contacts";
CREATE TABLE "supplier_contacts" (
"supplier_id"  INTEGER NOT NULL,		                        -- Ӧid; 
"supplier_contacts_id"  TEXT,			                        -- Ӧϵid; 
"supplier_contacts_name"  TEXT,			                        -- Ӧϵ;
"supplier_contacts_phone"  TEXT,		                        -- Ӧϵ˵绰;
"supplier_contacts_weixin"  TEXT,		                        -- Ӧϵ΢;
"supplier_contacts_qq"  TEXT,			                        -- ӦϵQQ; 
"supplier_contacts_email"  TEXT,		                        -- Ӧϵ;
"supplier_contacts_image"  BLOB,		                        -- Ӧϵͷ(ļ·)	
"supplier_contacts_grade"  INTEGER,		                        -- Ӧϵ˼(ϰ, ϰ, Ա, ҵԱȷ);
"supplier_contacts_native_place"  TEXT,	                        -- Ӧϵ˼();
"supplier_contacts_gender"  INTEGER,	                        -- ӦϵԱ;
"supplier_contacts_birthday"  TEXT,		                        -- Ӧϵ;
"supplier_contacts_remarks"  TEXT,		                        -- Ӧϵ˱ע;
"supplier_contacts_status"  INTEGER,	                        -- Ӧϵ״̬:Ч, Ч.
PRIMARY KEY ("supplier_id" ASC)
);

-- ----------------------------
-- Table structure for supplier_goods
-- Ӧ̹ӦƷ;
-- ҪƷ۸,ɫȾ,ΪƷ۸ḡ,ɫҲܻı,۸ڽ;
-- Ʒб, Ӧɾ, ֻ¼ܴ;
-- : Ӧ->Ʒ һĹϵ;
-- ----------------------------
DROP TABLE IF EXISTS "main"."supplier_goods";
CREATE TABLE "supplier_goods" (
"supplier_id"  INTEGER NOT NULL,                                -- Ӧid;
"supplier_goods_id"  INTEGER,                                   -- ӦƷid; 
"supplier_goods_name"  TEXT,                                    -- ӦƷ;
"supplier_goods_unit" TEXT,                                     -- ӦƷĵλ;
"supplier_goods_status" TEXT,                                   -- ӦƷ״̬:ϼ, ¼;
"supplier_goods_remarks"  TEXT,                                 -- ӦƷıע;
PRIMARY KEY ("supplier_id" ASC)
);

-- ----------------------------
-- Table structure for stock_goods
-- ;
-- ҪƷ۸,ɫȾ,ΪƷ۸ḡ,ɫҲܻı,۸ڽ;
-- ----------------------------
DROP TABLE IF EXISTS "main"."stock_goods";
CREATE TABLE "stock_goods" (
"supplier_id"  INTEGER NOT NULL,                                -- Ӧid;
"stock_goods_id"  INTEGER,                                      -- ; 
"supplier_goods_id"  INTEGER,                                   -- Ʒid; 
"supplier_goods_name"  TEXT,                                    -- Ʒ;
"supplier_goods_unit" TEXT,                                     -- Ʒĵλ;
"stock_goods_total_price"  TEXT,                                -- ܼ;
"quantity_of_goods"  TEXT,                                      -- Ʒ;
"transport_costs"  TEXT,                                        -- ;
"stock_goods_date"  TEXT,                                       -- ;
PRIMARY KEY ("supplier_id" ASC)
);

--1.α;
/* 
    , 
    Ʒ, 
    ʱ, 
    Ӧ, 
    ܼ, 
    ,
    ʵ(ʵ,ĳЩԭȱ),
    (Щ,),
    ϸ,
    , 
    ʱ,
    , 
    ˵, 
    αע, 
    Ƭ.
*/
CREATE TABLE [dbo].[basket_purchase](
	[basket_purchase_id] [nvarchar](50) NULL,									-- id;
	
) ON [PRIMARY]
GO

/*////////////////////////////////////////////////////////////////////////////////
------------------------------
ԱϢ: personnel
personnel_id: ȫid(ɷֵidǰ׺,ȹ̶4ֽ);
personnel_name: ;
personnel_gender: Ա;
personnel_native_place:;
personnel_identity_card:֤;
personnel_self_phone:绰(˵绰)
personnel_allocated_phone:ĵ绰(˾)
personnel_family_address:ͥסַ;
personnel_present_address:־ӵ;
personnel_weixin:΢ź;
personnel_self_qq:qq; 
personnel_allocated_qq;qq
personnel_seft_email;;
personnel_allocated_email;email(еĹ˾Լ)
personnel_educational_background;ѧ;
personnel_marital_status:״;
personnel_birthday;;
personnel_graduate_institutions:ҵԺУ;
personnel_fingerprinted1:ָ1;
personnel_fingerprinted2:ָ2;
personnel_probation_period:;
personnel_hiredate:ְ;
personnel_leavedate:ְ;
ֶ֤:ƬԴaliyun,ҲԴڱĿ¼;ݿ;
Ƭʹ'|'Żָ;
ϵ1, 绰, סַ, ϵ;
ϵ2, 绰, סַ, ϵ;
ע;
彡״:~~
ֵid(һֽ,ַʾA~Z);

------------------------------
ֵϢ:
branch_id:ֵid(һֽ,ַʾA~Z)
branch_name:ֵ;
branch_telphone:ֵ绰;
branch_address:ֵַ;
branch_website:ֵַ;
branch_publicwexin:ֵ깫ں;
branch_fax:ֵ괫;
branch_responsible:ֵ긺(곤);
branch_qr_codeֵά(·httpַ);


---------------------------
ͻ.
ͻ():
customer_id:ͻid(ȫΨһ)
customer_name:ͻ;
customer_gender:ͻԱ;
customer_birthday:ͻ();
customer_birthday_lunar:ͻǷũ;
customer_address:ͻסַ;
customer_phone:ͻ绰;
customer_weixin:ͻ΢;
customer_qq:ͻQQ; 
customer_email:ͻ;
customer_source:ͻԴ;


--------------------------
ͻ():



-------------------------
ͻϵ(һͻ,˲ϵ):
customer_id:ͻid
customer_relationship:ϵ(ʽ:ϵ-ӹϵ );
customer_persons:˻Ⱥ,һԶϵʱָʹ'|'
˵:ϵһһ, ҲһԶ.:-: ;

////////////////////////////////////////////////////////////////////////////////*/





(
Ʒ001ʱ, 10, 100, 100; 
Ʒ002ʱ, 15, 200, 250,ʾ50һε; 

ƷɱԶ仯, ۼҲԶ仯(ۼ = ɱ * %1.x ):
001ʱ, ɱ10, ֱֲ001ƷʹϺ;
002ʱ,  != 002ʱ, ɱ001ʱ, ֱ =002ʱʱ, ɱ=15;

һ, ЩƷɱۼ۶Ҫ̶;
)




