#include "stdafx.h"
#include "Global.h"
#include <locale.h>

namespace Global {
	BOOL g_bOurBranch = TRUE;
	BOOL g_bChildVersion = FALSE;
	TCHAR g_szIniName[MAX_PATH] = { 0 };
	TCHAR g_szClassicBranchId[MAX_PATH] = _T("");
	TCHAR g_szPlatinumBranchId[MAX_PATH] = _T("");
	TCHAR g_szModulePath[MAX_PATH] = _T("");			// Ŀ¼;
	TCHAR g_szModuleFileName[MAX_PATH] = _T("");		// ;
	TCHAR g_szClassicConnectString[MAX_PATH] = _T("");	// DBӴ;
	TCHAR g_szPlatinumConnectString[MAX_PATH] = _T("");	// DBӴ;
	TCHAR g_szAdoClassicConnectString[MAX_PATH] = _T("");	// DBӴ;
	TCHAR g_szAdoPlatinumConnectString[MAX_PATH] = _T("");	// DBӴ;
	TCHAR g_szOrders[1024 * 10] = {0};

	// Ϣ;
	TCHAR g_szClassicDBSource[MAX_PATH] = _T("");		// ݿԴ(IP);
	DWORD g_dwClassicDBServerPort = 0;					// ݿԴ˿;
	TCHAR g_szClassicDBAccount[MAX_PATH] = _T("");		// ݿ¼û;
	TCHAR g_szClassicDBPassWord[MAX_PATH] = _T("");		// ݿ¼;
	TCHAR g_szClassicDBName[MAX_PATH] = _T("");			// ݿ;	

	TCHAR g_szPlatinumDBSource[MAX_PATH] = _T("");		// ݿԴ(IP);
	DWORD g_dwPlatinumDBServerPort = 0;					// ݿԴ˿;
	TCHAR g_szPlatinumDBAccount[MAX_PATH] = _T("");		// ݿ¼û;
	TCHAR g_szPlatinumDBPassWord[MAX_PATH] = _T("");	// ݿ¼;
	TCHAR g_szPlatinumDBName[MAX_PATH] = _T("");		// ݿ;	

	TCHAR g_szPath1[MAX_PATH] = _T("");
	TCHAR g_szPath2[MAX_PATH] = _T("");
	TCHAR g_szPath3[MAX_PATH] = _T("");
	TCHAR g_szPath4[MAX_PATH] = _T("");

	TCHAR g_szComputerName[MAX_PATH] = {0};
	TCHAR g_szShareImgHost[MAX_PATH] = {0};
	BOOL g_IsConvMemberShip = FALSE;

	/************************************************************************/
	/*  [5/20/2016 IT];
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	int GetIniInfo(const TCHAR *szPath, const TCHAR *szIniName)
	{
		TCHAR szDrive[_MAX_DRIVE] = { 0 }, szDir[_MAX_DIR] = { 0 }, szFName[_MAX_FNAME] = { 0 }, szExt[_MAX_EXT] = { 0 };
		::GetModuleFileName(NULL, g_szModulePath, sizeof(g_szModulePath) / sizeof(TCHAR));
		_stprintf_s(g_szModuleFileName, _T("%s"), g_szModulePath);

		_tsplitpath_s(g_szModulePath, szDrive, szDir, szFName, szExt);
		_tcscpy_s(g_szModulePath, szDrive), _tcscat_s(g_szModulePath, szDir);

		if (szPath != NULL && szIniName != NULL)
			_stprintf_s(g_szIniName, _T("%s\\%s"), szPath, szIniName);
		else
			_stprintf_s(g_szIniName, _T("%sc2p.ini"), g_szModulePath);

		// ȡ;
		DWORD dwLength = MAX_PATH;
		if (!::GetComputerName(g_szComputerName, &dwLength))
		{
			WriteTextLog(_T("ȡʧ!"));
		}

		// ȡָIPַ//ȡIPַ;


		HANDLE hFile = CreateFile(g_szIniName, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
		if (ERROR_FILE_NOT_FOUND == GetLastError())
			return -1;

		CloseHandle(hFile), hFile = NULL;

		g_bChildVersion = GetPrivateProfileInt(_T("ClassicInfo"), _T("IsChildVersion"), 0, g_szIniName);
		// ȡϢ;g_bChildVersion
		{
			GetPrivateProfileString(_T("ClassicInfo"), _T("BranchId"), _T(""), g_szClassicBranchId, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("dbSource"), _T(""), g_szClassicDBSource, MAX_PATH, g_szIniName);
			g_dwClassicDBServerPort = GetPrivateProfileInt(_T("ClassicInfo"), _T("dbServerPort"), 0, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("dbAccount"), _T(""), g_szClassicDBAccount, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("dbPassWord"), _T(""), g_szClassicDBPassWord, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("dbName"), _T(""), g_szClassicDBName, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("ShareImgHost"), _T(""), g_szShareImgHost, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("ClassicInfo"), _T("Orders"), _T(""), g_szOrders, 1024*10, g_szIniName);
			g_bOurBranch = GetPrivateProfileInt(_T("ClassicInfo"), _T("IsOurBranch"), 1, g_szIniName);
			g_IsConvMemberShip = GetPrivateProfileInt(_T("ClassicInfo"), _T("IsConvMemberShip"), 1, g_szIniName);
			if (g_dwClassicDBServerPort != 0)
			{
				if (_tcscmp(g_szClassicDBAccount, _T("")) == 0)
					_stprintf_s(g_szClassicConnectString, DB_SW_CONN_WITH_PORT, g_szClassicDBSource, g_dwClassicDBServerPort, g_szClassicDBName);
				else
					_stprintf_s(g_szClassicConnectString, DB_SS_CONN_WITH_PORT, g_szClassicDBSource, g_dwClassicDBServerPort, g_szClassicDBName, g_szClassicDBAccount, g_szClassicDBPassWord);

				_stprintf_s(g_szAdoClassicConnectString,
					_T("Provider=sqloledb;Data Source=%s,%ld;Initial Catalog=%s;User Id=%s;Password=%s; "),
					g_szClassicDBSource,			// IPַ;
					g_dwClassicDBServerPort,
					g_szClassicDBName,
					g_szClassicDBAccount,
					g_szClassicDBPassWord);
			}
			else
			{
				if (_tcscmp(g_szClassicDBAccount, _T("")) == 0)
					_stprintf_s(g_szClassicConnectString, DB_SW_CONN_WITHOUT_PORT, g_szClassicDBSource, g_szClassicDBName);
				else
					_stprintf_s(g_szClassicConnectString, DB_SS_CONN_WITHOUT_PORT, g_szClassicDBSource, g_szClassicDBName, g_szClassicDBAccount, g_szClassicDBPassWord);

				_stprintf_s(g_szAdoClassicConnectString,
					_T("Provider=sqloledb;Data Source=%s;Initial Catalog=%s;User Id=%s;Password=%s; "),
					g_szClassicDBSource,			// IPַ;
					g_szClassicDBName,
					g_szClassicDBAccount,
					g_szClassicDBPassWord);
			}
		}

		// ȡϢ;
		{
			GetPrivateProfileString(_T("PlatinumInfo"), _T("BranchId"), _T(""), g_szPlatinumBranchId, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("dbSource"), _T(""), g_szPlatinumDBSource, MAX_PATH, g_szIniName);
			g_dwPlatinumDBServerPort = GetPrivateProfileInt(_T("PlatinumInfo"), _T("dbServerPort"), 0, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("dbAccount"), _T(""), g_szPlatinumDBAccount, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("dbPassWord"), _T(""), g_szPlatinumDBPassWord, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("dbName"), _T(""), g_szPlatinumDBName, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("Path1"), _T(""), g_szPath1, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("Path2"), _T(""), g_szPath2, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("Path3"), _T(""), g_szPath3, MAX_PATH, g_szIniName);
			GetPrivateProfileString(_T("PlatinumInfo"), _T("Path4"), _T(""), g_szPath4, MAX_PATH, g_szIniName);

			if (g_dwPlatinumDBServerPort != 0)
			{
				if (_tcscmp(g_szPlatinumDBAccount, _T("")) == 0)
					_stprintf_s(g_szPlatinumConnectString, DB_SW_CONN_WITH_PORT, g_szPlatinumDBSource, g_dwPlatinumDBServerPort, g_szPlatinumDBName);
				else
					_stprintf_s(g_szPlatinumConnectString, DB_SS_CONN_WITH_PORT, g_szPlatinumDBSource, g_dwPlatinumDBServerPort, g_szPlatinumDBName, g_szPlatinumDBAccount, g_szPlatinumDBPassWord);

				_stprintf_s(g_szAdoPlatinumConnectString,
					_T("Provider=sqloledb;Data Source=%s,%ld;Initial Catalog=%s;User Id=%s;Password=%s; "),
					g_szPlatinumDBSource,			// IPַ;
					g_dwPlatinumDBServerPort,
					g_szPlatinumDBName,
					g_szPlatinumDBAccount,
					g_szPlatinumDBPassWord);
			}
			else
			{
				if (_tcscmp(g_szPlatinumDBAccount, _T("")) == 0)
					_stprintf_s(g_szPlatinumConnectString, DB_SW_CONN_WITHOUT_PORT, g_szPlatinumDBSource, g_szPlatinumDBName);
				else
					_stprintf_s(g_szPlatinumConnectString, DB_SS_CONN_WITHOUT_PORT, g_szPlatinumDBSource, g_szPlatinumDBName, g_szPlatinumDBAccount, g_szPlatinumDBPassWord);

				_stprintf_s(g_szAdoPlatinumConnectString,
					_T("Provider=sqloledb;Data Source=%s;Initial Catalog=%s;User Id=%s;Password=%s; "),
					g_szPlatinumDBSource,			// IPַ;
					g_szPlatinumDBName,
					g_szPlatinumDBAccount,
					g_szPlatinumDBPassWord);
			}
		}

		return 0;
	}

	/************************************************************************/
	/*  WriteTextLog[7/28/2016 IT];
	/*  дı־;
	/*  ;
	/*  	[IN] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void WriteTextLog(const TCHAR *format, ...)
	{
		try
		{
			static std::mutex _mutex;
			std::unique_lock <std::mutex> lock{ _mutex };
			// ־·;
			TCHAR szlogpath[MAX_PATH] = { 0 };
			_stprintf_s(szlogpath, _T("%s%s.txt"), g_szModulePath, CTime::GetCurrentTime().Format("log-%m-%d").GetString());

			// 򿪻򴴽ļ;
			CStdioFile fp;
			if (PathFileExists(szlogpath))
			{
				if (fp.Open(szlogpath, CFile::modeWrite) == FALSE)
				{
					return;
				}
				fp.SeekToEnd();
			}
			else
			{
				if (!fp.Open(szlogpath, CFile::modeCreate | CFile::modeWrite))
					return;
			}

			// ʽǰ;
			TCHAR* old_locale = _tcsdup(_tsetlocale(LC_CTYPE, NULL));
			_tsetlocale(LC_CTYPE, _T("chs"));//趨;

			// ʽ־;
			va_list		args = NULL;
			int			len = 0;
			TCHAR		*buffer = NULL;
			va_start(args, format);
			// _vscprintf doesn't count. terminating '\0'
			len = _vsctprintf_p(format, args);
			if (len == -1)
			{
				goto clear;
			}

			len++;
			buffer = (TCHAR*)malloc(len * sizeof(TCHAR));
			_vstprintf_s(buffer, len, format, args); // C4996
			// Note: vsprintf is deprecated; consider using vsprintf_s instead

			// ־뵽ļ;
			fp.WriteString(CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S ")));
			fp.WriteString(buffer);
			fp.WriteString(_T("\n"));

			// رļͷԴûԭ;
			free(buffer);
		clear:
			_tsetlocale(LC_CTYPE, old_locale);
			free(old_locale);//ԭ趨;
			fp.Close();
		}
		catch (CException *e)
		{
			e->ReportError();
			e->Delete();
		}
	}

	/************************************************************************/
	/*  ַתDATE[4/27/2018 Jeff];
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺ַ 2018/01/01 10:10:10  2018-01-01 10:10:10 ʽ;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	DATE String2Date(CString strDate)
	{
		COleDateTime oletime;
		if (strDate.GetLength() <= 10)
			oletime.SetDate(_ttoi(strDate.Left(4)), _ttoi(strDate.Mid(5, 2)), _ttoi(strDate.Mid(8, 2)));
		else
			oletime.SetDateTime(_ttoi(strDate.Left(4)), _ttoi(strDate.Mid(5, 2)), _ttoi(strDate.Mid(8, 2)), _ttoi(strDate.Mid(11, 2)), _ttoi(strDate.Mid(14, 2)), _ttoi(strDate.Mid(17, 2)));

		return oletime.m_dt;
	}

	_variant_t GetFieldBSTRValue(_variant_t &field, CString strDefault)
	{
		_variant_t result(strDefault);
		result.vt = VT_BSTR;
		if (field.vt == VT_NULL)
		{

		}

		return _variant_t();
	}

	CString ShowFolder()
	{
		TCHAR           szFolderPath[MAX_PATH] = { 0 };
		CString         strFolderPath = TEXT("");

		BROWSEINFO      sInfo;
		::ZeroMemory(&sInfo, sizeof(BROWSEINFO));
		sInfo.pidlRoot = 0;
		sInfo.lpszTitle = _T("ѡһļУ");
		sInfo.ulFlags = BIF_DONTGOBELOWDOMAIN | BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE | BIF_EDITBOX;
		sInfo.lpfn = NULL;

		// ʾļѡԻ  
		LPITEMIDLIST lpidlBrowse = ::SHBrowseForFolder(&sInfo);
		if (lpidlBrowse != NULL)
		{
			// ȡļ  
			if (::SHGetPathFromIDList(lpidlBrowse, szFolderPath))
			{
				strFolderPath = szFolderPath;
			}
		}
		if (lpidlBrowse != NULL)
		{
			::CoTaskMemFree(lpidlBrowse);
		}

		return strFolderPath;
	}

	CString EncodeHex16String(CString str)
	{
#ifdef _UNICODE
		string result;
		string strgbk = convert("UCS-2LE", "GBK", (const char*)str.GetBuffer(0), str.GetLength() * sizeof(TCHAR));
		// תutf-8ʽ;
		string strutf8 = convert("GBK", "UTF-8", strgbk.c_str(), strgbk.size());

		char szHex[5] = { 0 };
		for ( int i = 0; i < strutf8.size(); i++ )
		{
			szHex[4] = '\0';
			if (strutf8[i] > 0)
				sprintf_s(szHex, "%04X", strutf8[i]);
			else
				sprintf_s(szHex, "%04X", 256 + strutf8[i]);
			result.append(szHex);
		}

		TString strResponse;
		strResponse.append((TCHAR*)((convert("GBK", "UCS-2LE", result.c_str(), result.size())).c_str()), result.size());
		return strResponse.c_str();
#else
		char szHex[5] = {0};
		CString result;
		// תutf-8ʽ;
		string strutf8 = convert("GBK", "UTF-8", (const char*)str.GetBuffer(0), str.GetLength());
		for ( int i = 0; i < strutf8.size(); i++)
		{
			szHex[4] = '\0';
			if ( strutf8[i] > 0 )
				sprintf_s(szHex, "%04X", strutf8[i]);
			else
				sprintf_s(szHex, "%04X", 256 + strutf8[i]);
			result += szHex;
		}

		return result.c_str();
#endif
	}

	CString GetHostByName(CString strHostName)
	{
		WSADATA wsaData;
		int iResult;

		DWORD dwError;
		int i = 0;

		struct hostent *remoteHost;
		struct in_addr addr;

		char **pAlias;

		// Initialize Winsock;
		iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
		if (iResult != 0) {
			WriteTextLog(_T("WSAStartup failed: %d\n"), iResult);
			return _T("");
		}

#ifdef _UNICODE
		std::string strhostname = convert("UCS-2LE", "GBK", (const char*)strHostName.GetBuffer(0), strHostName.GetLength() * sizeof(TCHAR));
#else
		std::string strhostname = strHostName;
#endif

		std::string strAddr;
		remoteHost = gethostbyname(strhostname.c_str());

		if (remoteHost == NULL) {
			dwError = WSAGetLastError();
			if (dwError != 0) {
				if (dwError == WSAHOST_NOT_FOUND) {
					printf("Host not found\n");
					return _T("");
				}
				else if (dwError == WSANO_DATA) {
					printf("No data record found\n");
					return _T("");
				}
				else {
					printf("Function failed with error: %ld\n", dwError);
					return _T("");
				}
			}
		}
		else {
			printf("Function returned:\n");
			printf("\tOfficial name: %s\n", remoteHost->h_name);
			for (pAlias = remoteHost->h_aliases; *pAlias != 0; pAlias++) {
				printf("\tAlternate name #%d: %s\n", ++i, *pAlias);
			}
			printf("\tAddress type: ");
			switch (remoteHost->h_addrtype) {
			case AF_INET:
				printf("AF_INET\n");
				break;
			case AF_NETBIOS:
				printf("AF_NETBIOS\n");
				break;
			default:
				printf(" %d\n", remoteHost->h_addrtype);
				break;
			}
			printf("\tAddress length: %d\n", remoteHost->h_length);

			i = 0;
			if (remoteHost->h_addrtype == AF_INET)
			{
				/*while (remoteHost->h_addr_list[i] != 0) {
					addr.s_addr = *(u_long *)remoteHost->h_addr_list[i++];
					printf("\tIP Address #%d: %s\n", i, inet_ntoa(addr));
				}*/
				// ֻȡһ,;
				if (remoteHost->h_addr_list[0] != 0)
				{
					addr.s_addr = *(u_long *)remoteHost->h_addr_list[i++];
					strAddr = inet_ntoa(addr);
				}
			}
			else if (remoteHost->h_addrtype == AF_NETBIOS)
			{
				printf("NETBIOS address was returned\n");
			}
		}

#ifdef _UNICODE
		string result = convert("GBK", "UCS-2LE", strAddr.c_str(), strAddr.size());
		TString strResponse;
		strResponse.append((TCHAR*)(result.c_str()), result.size() / 2);
		return strResponse.c_str();
#else
		return strAddr.c_str();
#endif
	}

	CString DecodeHex16String(CString str)
	{
#ifdef _UNICODE
		string strutf8;
		// תgbk; 
		string strgbk = convert("UCS-2LE", "GBK", (const char*)str.GetBuffer(0), str.GetLength() * sizeof(TCHAR));
		for ( int i = 0; i < strgbk.size(); i += 4)
		{
			strutf8.append(1, strtoul(strgbk.substr(i,4).c_str(), NULL, 16));
		}
		// utf8תgbk; 
		string result = convert("utf-8", "GBK", strutf8.c_str(), strutf8.size());		
		result = convert("GBK", "UCS-2LE", result.c_str(), result.size());
		TString strResponse;
		strResponse.append((TCHAR*)(result.c_str()), result.size()/2);
		return strResponse.c_str();
#else
		string strutf8;
		for ( int i = 0; i < strgbk.size(); i += 4 )
		{
			strutf8.append(1, strtoul(strgbk.substr(i, 4).c_str(), NULL, 16));
		}
		// utf8תgbk; 
		string result = convert("utf-8", "GBK", strutf8.c_str(), strutf8.size());
		return result.c_str();
#endif
	}

	/************************************************************************/
	/*  GetErrorInfo[9/13/2016 IT];
	/*  ȡָľ;
	/*  ;
	/*  	[IN] dwError;
	/*  أCString;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	CString GetErrorInfo(const DWORD &dwError)
	{
		LPVOID lpMsgBuf;
		CString strErrorInfo;
		BOOL fOk = FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			dwError,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&lpMsgBuf,
			0, NULL
		);

		if (!fOk)
		{
			// Is it a network-related error?
			HMODULE hDll = LoadLibraryEx(TEXT("netmsg.dll"), NULL, DONT_RESOLVE_DLL_REFERENCES);

			if (hDll != NULL)
			{
				FormatMessage(
					FORMAT_MESSAGE_FROM_HMODULE | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
					hDll, dwError,
					MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),
					(LPTSTR)&lpMsgBuf,
					0, NULL
				);

				FreeLibrary(hDll);
			}
		}

		if (lpMsgBuf != NULL)
		{
			strErrorInfo.Format(_T("=%d,ϵͳ%s"), dwError, (PCTSTR)LocalLock(lpMsgBuf));
			LocalFree(lpMsgBuf);
		}
		else
		{
			strErrorInfo.Format(_T("=%d,ϵͳδ֪ݣ"), dwError);
		}

		return strErrorInfo;
	}
}